routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('layout');
//});
//Route::resource('agences', 'AgenceController');
//Route::resource('regionals', 'RegionalController');
//Route::resource('centrals', 'CentralController');
//Route::resource('structures/{type_id}', 'StructureController');
Auth::routes();
Route::get('/', 'HomeController@index')->name('home');
Route::middleware(['web'])->group(function () {



    Route::get('historiques', 'HistoryController@index');
    Route::resource('user', 'UserController');
    Route::put('user/{id}/edit', 'UserController@password')->name('user.password');
    Route::resource('document', 'DocumentController');
    Route::resource('nomenclature', 'NomenclatureController');
    Route::resource('calendrier', 'CalendrierController');
    Route::get('versement', 'VersementController@index')->name('versement.index');
    Route::post('versement', 'VersementController@decision')->name('versement.decision');
    Route::get('demande', 'DemandeController@index')->name('demande.index');
    Route::post('demande/{id}', 'DemandeController@decision')->name('demande.decision');

    Route::get('/ajax/structurestype/{type?}', 'UserController@StructuresType')->name('ajax.structurestype');
    Route::get('structures/{type_id}', 'StructureController@index')->name('structure.index');
    Route::get('structures/{type_id}/create', 'StructureController@create')->name('structure.create');
    Route::post('structures/{type_id}', 'StructureController@store')->name('structure.store');
    Route::get('structures/{type_id}/{structure}/edit', 'StructureController@edit')->name('structure.edit');
    Route::put('structures/{type_id}/{structure}', 'StructureController@update')->name('structure.update');
    Route::get('structures/{type_id}/{structure}', 'StructureController@show')->name('structure.show');
    Route::delete('structures/{type_id}/{structure}', 'StructureController@destroy')->name('structure.delete');

    Route::get('consultation', 'ConsultationController@index')->name('consultation.index');
    Route::post('consultation/create', 'ConsultationController@store')->name('consultation.store');
    Route::get('consultation/create', 'ConsultationController@create')->name('consultation.create');
    Route::post('consultation/{id}', 'ConsultationController@decision')->name('consultation.decision');


    Route::get('enlevement/demandes', 'EnlevementController@demandes')->name('enlevement.demandes');
    Route::put('enlevement/demandes/{enlevement}', 'EnlevementController@date')->name('enlevement.date');
    Route::get('enlevement/calendar', 'EnlevementController@calendar')->name('enlevement.calendar');
    Route::resource('enlevement', 'EnlevementController');


});

app/Consultation.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Consultation extends Model
{
    protected $guarded=[];

    public function user()
    {
        return $this->belongsTo('App\User');
    }
    public function consultationPrearchive($companyid)
    {
        return Consultation::join('users','users.id','orders.user_id')
            ->where('users.company_id',$companyid);
    }
}

app/Http/Controllers/ConsultationController.php
<?php

namespace App\Http\Controllers;

use App\Consultation;
use App\Document;
use App\History;
use App\Structure;
use App\User;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class ConsultationController extends Controller
{

    public function index()
    {
        $age2=Auth::user()->structure->id;
        if(Auth::user()->structure->type->id==4)
        {
            $consultations=Consultation::join('structures','structures.id','consultations.structure_id')
//                ->join('structures','users.structure_id','structures.id')
                ->where('structures.age2',$age2)
                ->select('consultations.*')
                ->get();
//                    dd($consultations);
        }
        else
            $consultations=Consultation::where('user_id',Auth::user()->id)->get();

        return view('consultations.index',compact('consultations'));
    }


    public function create()
    {
        return view('consultations.create');
    }


    public function store(Request $request)
    {

        $consultation=new Consultation();
        $document=Document::where('structure_id',Auth::user()->structure->id)
            ->where('statut',2);
        if($document->where('num',$request->num)->count()==0)
        {
          return redirect()->back()->with('error','numéro introuvable');
        }
        else
        $consultation->num=$request->num;
        $consultation->raison=$request->raison;
        $consultation->objet=$request->objet;
        $consultation->decision=0;
        $consultation->statut=0;
        $consultation->user_id=Auth::user()->id;
        $consultation->structure_id=Auth::user()->structure_id;
        $consultation->date=Carbon::now();
        $consultation->save();
      History::create([
            'structure_id'=>Auth::user()->structure->id,
            'user_id'=>Auth::id(),
            'action'=>'Consultation'
        ]);
        return redirect(route('consultation.index'));

   }

    public function decision(Request $request,$id)
    {
        $consultation=Consultation::find($id);
        if($request->decision=="0")
        {
            $consultation->decision="1";
            $consultation->statut=2;
            $consultation->date=$request->date;
            History::create([
                'structure_id'=>Auth::user()->structure->id,
                'user_id'=>Auth::id(),
                'action'=>'Demande de Consultation Refusée'
            ]);
        }
        elseif($request->decision=="1")
        {
            $consultation->decision=1;
            $consultation->statut=1;
            $consultation->date=$request->date;
            History::create([
                'structure_id'=>Auth::user()->structure->id,
                'user_id'=>Auth::id(),
                'action'=>'Demande de Consultation Acceptée'
            ]);
        }
        $consultation->save();

        return redirect(route('consultation.index'));
    }


    public function edit(Consultation $consultation)
    {
        //
    }


    public function update(Request $request, Consultation $consultation)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Consultation  $consultation
     * @return \Illuminate\Http\Response
     */
    public function destroy(Consultation $consultation)
    {
        //
    }
}

resources/views/consultations/create.blade.php
@extends('layout')
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont
                    icofont-file-alt
                        bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Consultation</h4>
                        <span>Créer Une Demande de <code style="text-transform: uppercase">Consultation</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Créer Une Demande de Consultation</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- Basic Form Inputs card start -->
                <div class="card">

                    <div class="card-block">
                        <h4 class="sub-title">Formulaire de création</h4>
                        <form method="post" action="{{route('consultation.store')}}">
                            @csrf
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Numéro document</label>
                                <div class="col-sm-10">
                                    <input name="num" type="text" class="form-control" placeholder="Numéro document">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Raison</label>
                                <div class="col-sm-10">
                                    <input name="raison" type="text" class="form-control" placeholder="Raison">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Objet</label>
                                <div class="col-sm-10">
                                    <textarea name="objet" type="text" class="form-control" placeholder="Objet">
                                    </textarea>
                                </div>
                            </div>

                            <div class="text-center">
                            <button type="submit" class="col-md-3 btn btn-out-dashed btn-success btn-square">Créer</button>
                            </div>
                        </form>
                    </div>
                </div>
                <!-- Basic Form Inputs card end -->
            </div>
        </div>

    </div>
@endsection

resources/views/consultations/edit.blade.php
@extends('layout')
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont
                    icofont-file-alt
                        bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Document</h4>
                        <span>Modifier Un<code style="text-transform: uppercase">Document</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Modifier Un Document</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- Basic Form Inputs card start -->
                <div class="card">

                    <div class="card-block">
                        <h4 class="sub-title">Formulaire de Modification</h4>
                        <form method="post" action="{{route('document.update',$document->id)}}">
                            @csrf
                            @method('put')
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Numéro document</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->num}}" name="num" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre pages</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->pages}}"  name="pages" type="text" class="form-control" placeholder="Nombre pages">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre documents</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->nbrdoc}}" name="nbrdoc" type="text" class="form-control" placeholder="Nombre documents">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Chapitre Comptable</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->chapitre}}" name="chapitre" type="text" class="form-control" placeholder="Chapitre Comptable">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nomenclature</label>
                                <div class="col-sm-10">
                                    <select required name="nomenclature" class="form-control">
                                        <option disabled selected >Choisir la nomenclature</option>
                                        @foreach($nomenclatures as $nomenclature)
                                            <option {{$document->nomenclature->id==$nomenclature->id ? 'selected' : ''}} value="{{$nomenclature->id}}">{{$nomenclature->designation}}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <div class="text-center">
                                <button type="submit" class="col-md-3 btn btn-out-dashed btn-success btn-square">Modifier</button>
                            </div>
                        </form>
                    </div>
                </div>
                <!-- Basic Form Inputs card end -->
            </div>
        </div>

    </div>
@endsection

resources/views/consultations/index.blade.php
@extends('layout')
@section('nom')

@endsection
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont
                    icofont-file-alt
                        bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Demande Consultation</h4>
                        <span>Liste Des <code style="text-transform: uppercase">Consultations</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Liste des Demandes de Consultation</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- DOM/Jquery table start -->
                <div class="card">

                    <div class="card-block">
                        @if((Auth::user()->structure->type->id!=4)&&(Auth::user()->structure->type->id!=5))
                        <a href="{{route('consultation.create')}}" type="button" id="addRow" class="btn btn-primary m-b-20 float-lg-right">+ Créer Une Nouvelle Demande de Consultation
                        </a>
                        @endif
                        <div class="table-responsive dt-responsive">
                            <table id="dom-jqry" class="table table-striped table-bordered nowrap">
                                <thead>
                                <tr>
                                    <th>Numéro Document</th>
                                    <th>Raison</th>
                                    <th>Objet</th>
                                    <th>Statut</th>
                                    <th>Date</th>
                                    @if(Auth::user()->structure->type->id==4)
                                        <th>Utilisateur</th>
                                        <th>Structure</th>
                                        <th>Actions</th>
                                    @endif
                                </tr>
                                </thead>
                                <tbody>
                                @foreach($consultations as $consultation)
                                    <tr>
                                        <td>{{$consultation->num}}</td>
                                        <td>{{$consultation->raison}}</td>
                                        <td>{{$consultation->objet}}</td>
                                        <td>
                                            @if($consultation->statut==0)
                                            <span class="badge badge-light badge-warning">En Attente</span>
                                            @elseif($consultation->statut==1)
                                            <span class="badge badge-light badge-success">Acceptée</span>
                                            @else
                                            <span class="badge badge-light badge-danger">Réfusée</span>
                                            @endif

                                        </td>
                                        <td>{{$consultation->date ? $consultation->date :'la demande n'.'\''.'as pas encore été traiter' }}</td>
                                        @if(Auth::user()->structure->type->id==4)
                                        <td>{{$consultation->user->name}}</td>
                                        <td>{{$consultation->user->structure->type->name.' '.$consultation->user->structure->adresse}}</td>
                                        <td>
                                            @if($consultation->statut==0)
                                            <button class="badge badge-md bg-success" data-toggle="modal"
                                                    data-target="#prearchivage{{$consultation->id}}">Accepter</button>
                                            <a href="#" data-toggle="modal"
                                               data-target="#suppression{{$consultation->id}}" class="badge badge-md bg-danger">Refuser</a>
                                            @endif
                                        </td>

                                        @endif
                                    </tr>
                                    <div class="modal fade" id="prearchivage{{$consultation->id}}" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h4 class="modal-title">Accepter la Demande de consultation</h4>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    <h5>Etes vous sûr de vouloir Accepter la Demande de consultation de ce document par {{$consultation->user->name}}?</h5>
                                                </div>
                                                <div class="modal-footer">
                                                    <form method="post" action="{{route('consultation.decision',$consultation->id)}}">
                                                        @csrf
                                                        <input type="hidden" name="decision" value="1">
{{--                                                        <input type="hidden" name="consultation" value="{{$consultation->id}}">--}}
                                                        <label>sélectionner  la date </label>
                                                        <input type="date" name="date" >
                                                        <button type="button" class="btn btn-default waves-effect " data-dismiss="modal">Non</button>
                                                        <button type="submit" class="btn btn-primary waves-effect waves-light ">Oui</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="modal fade" id="suppression{{$consultation->id}}" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h4 class="modal-title">Confirmation de Suppression</h4>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    <h5>Etes vous sûr de vouloir Refuser cette demande de consultation ?</h5>
                                                </div>
                                                <div class="modal-footer">
                                                    <form method="post" action="{{route('consultation.decision',$consultation->id)}}">
                                                        @csrf
                                                        <input type="hidden" name="decision" value="0">
                                                        <button type="button" class="btn btn-default waves-effect " data-dismiss="modal">Non</button>
                                                        <button type="submit" class="btn btn-primary waves-effect waves-light ">Oui</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                @endforeach
                                </tbody>
                                <tfoot>
                                <tr>
                                    <th>Numéro Document</th>
                                    <th>Raison</th>
                                    <th>Objet</th>
                                    <th>Statut</th>
                                    <th>Date</th>
                                    @if(Auth::user()->structure->type->id==4)
                                    <th>Utilisateur</th>
                                    <th>Structure</th>
                                    <th>Actions</th>
                                    @endif
                                </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
                <!-- DOM/Jquery table end -->
            </div>
        </div>
    </div>
@endsection
@section('scripts')
    <script>
        function ShowModalPrearchivage(documentid) {
            $('.doc_id').val(documentid);
            $('#prearchivage').modal('show');
        }
        function ShowModalSuppression(documentid) {
            $('.doc_id').val(documentid);
            $('#suppression').modal('show');
        }
    </script>
@endsection

resources/views/consultations/show.blade.php
@extends('layout')
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont
                    icofont-file-alt
                        bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Document</h4>
                        <span>Afficher Un<code style="text-transform: uppercase">Document</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Afficher Un Document</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- Basic Form Inputs card start -->
                <div class="card">

                    <div class="card-block">
                        <h4 class="sub-title">Informations d'un document</h4>
                        <div>

                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Numéro document</label>
                                <div class="col-sm-10">
                                    <p>{{$document->num}}</p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre pages</label>
                                <div class="col-sm-10">
                                    <p>{{$document->pages}}</p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre documents</label>
                                <div class="col-sm-10">
                                    <p>{{$document->nbrdoc}}</p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Chapitre Comptable</label>
                                <div class="col-sm-10">
                                    <p>{{$document->chapitre}}</p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nomenclature</label>
                                <div class="col-sm-10">
                                    {{$document->nomenclature->designation}}
                                </div>
                            </div>
                            <div class="col-md-12 text-center">
                                <a href="{{route('document.edit',$document->id)}}" class="col-md-4 btn btn-out-dashed btn-success btn-square">Modifier</a>
                                <a href="{{route('document.index')}}" class="col-md-4 btn btn-out-dashed btn-info btn-square">Retour</a>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Basic Form Inputs card end -->
            </div>
        </div>

    </div>
@endsection